+++
title = "数据库发现"
weight = 5
+++

## 定义

```sql
SHOW DB_DISCOVERY RULES [FROM schemaName]
```

## 说明

| 列                       | 说明            |
| ------------------------ | --------------- |
| name                     | 规则名称         |
| data_source_names        | 数据源名称列表    |
| primary_data_source_name | 主数据源名称      |
| discover_type            | 数据库发现服务类型 |
| discover_props           | 数据库发现服务参数 |

## 示例

```sql
mysql> show db_discovery rules from database_discovery_db;
+-------+---------------------+--------------------------+---------------+------------------------------------------------------------------------------------------------------------+
| name  | data_source_names   | primary_data_source_name | discover_type | discover_props                                                                                             |
+-------+---------------------+--------------------------+---------------+------------------------------------------------------------------------------------------------------------+
| pr_ds | ds_0, ds_1, ds_2    | ds_0                     | MGR           | keepAliveCron=0/50 * * * * ?, zkServerLists=localhost:2181, groupName=b13df29e-90b6-11e8-8d1b-525400fc3996 |
+-------+---------------------+--------------------------+---------------+------------------------------------------------------------------------------------------------------------+
1 row in set (0.00 sec)
```
